RequireSystemScript("colors.js");
RequireScript("Jest_Calc.js");
RequireScript("Jest_Ball.js");
RequireScript("Jest_Padl.js");
RequireScript("Jest_Blck.js");
RequireScript("Jest_Drop.js");
RequireScript("Jest_Sound.js");
RequireScript("Jest_Sphere.js");
RequireScript("Jest_Editor.js");

var font = LoadFont("jest.rfn");
font.setColorMask(CreateColor(200,200,200,255))
var font2 = LoadFont("jest.rfn");
font2.setColorMask(CreateColor(100,100,100,200))

var S_bounce 	= LoadSoundEffect("bounce.wav", SE_MULTIPLE);
var S_break 	= LoadSoundEffect("break.wav", SE_MULTIPLE);
var S_crystal	= LoadSoundEffect("crystal.wav", SE_MULTIPLE);

var randcd = 100;

var score = 0;
var lives = 4;
var level = 1;
var debug = false

var balls = []
var paddles = []
var blocks = []
var drops = []
function game(){
while(true){
score = 0;
lives = 6;
level = 1;
debug = false

balls = []
paddles = []
blocks = []
drops = []
doitall()}
}

function drawHud(){
Rectangle(0,0,GetScreenWidth(), 32, Blue)
OutlinedRectangle(2, 2, GetScreenWidth()-3, 29, CreateColor(100,100,100,200))
OutlinedRectangle(1, 1, GetScreenWidth()-3, 29, CreateColor(200,200,200,200))
Line(0, 32, GetScreenWidth(), 32, CreateColor(200,200,200,200))
Line(0, 33, GetScreenWidth(), 33, CreateColor(100,100,100,200))
font2.drawText(11,11,"SCORE: " + score)
font.drawText(10,10,"SCORE: " + score)

font2.drawText(121,11,"LEVEL: " + level)
font.drawText(120,10,"LEVEL: " + level)

font2.drawText(211,11,"BLOCKS: "+blocks.length)
font.drawText(210,10,"BLOCKS: "+blocks.length)

font2.drawText(321,11,"LIVES: ")
font.drawText(320,10,"LIVES: ")

var i = 0;
	while(i<lives){
	FilledCircle(330+font.getStringWidth("LIVES: ")+18*i, 16, 8, White);
	i++
	}

}

var lasttrajmod = 0;


function pause(){
while(IsAnyKeyPressed()){}
while(AreKeysLeft()){GetKey()}
//font.drawText(10,10,balls[0].traj);
font2.drawZoomedText(112, 78, 2.3, "Jester's Breakout")
font.drawZoomedText(110, 76, 2.3, "Jester's Breakout")

font2.drawZoomedText(187, 178, 2.3, "PAUSED")
font.drawZoomedText(185, 176, 2.3, "PAUSED")
FlipScreen();

while(!IsAnyKeyPressed()){}
while(IsAnyKeyPressed()){}
while(AreKeysLeft()){GetKey()}

for(var i = 0; i<balls.length; i++){
balls[i].lastmoved = GetTime();
}
for(var i = 0; i<drops.length; i++){
drops[i].lastmoved = GetTime();
}

}



function gameover(){
while(IsAnyKeyPressed()){}
while(AreKeysLeft()){GetKey()}
font2.drawZoomedText(112, 78, 2.3, "Jester's Breakout")
font.drawZoomedText(110, 76, 2.3, "Jester's Breakout")

font2.drawZoomedText(167, 178, 2.3, "GAMEOVER")
font.drawZoomedText(165, 176, 2.3, "GAMEOVER")
FlipScreen();

while(!IsAnyKeyPressed()){}
while(IsAnyKeyPressed()){}
while(AreKeysLeft()){GetKey()}

}


function doitall(){
FlipScreen();
paddles.push(new paddle(0, GetScreenHeight()-48,GetScreenWidth(), Yellow));
titlescreen();
S_crystal.play();
while(AreKeysLeft()){GetKey()}
//As elegant as it is to see the screen as a set of blocks, it is slow.
//							block(x, 	y, 	hp,	drop, imageorheight, width, color)
//blocks.push(new block(64, 64, 1, new drop(96, 96, 1, LoadImage("bluepowerup.tga"),decrementballspeed), 					16, 	64, 		Red));
paddles[0] = new paddle(10, GetScreenHeight()-26,100, Yellow);
LoadLevel(level);
while(true){
if(blocks.length==0){level++; LoadLevel(Math.min(level, 5));}
var fips = GetTime();
processBlocks();
if(IsKeyPressed(KEY_P)){pause()}
processBalls(true);
processPaddles(true);
if(drops.length>0) {processDrops()}
drawHud();
randcd--;
if(debug){
FilledCircle(GetMouseX(), GetMouseY(), 8, White);
Line(GetMouseX(), GetMouseY(), GetMouseX(), GetScreenHeight(), White);
var angle = -((1.1*(Math.PI/2))-((Math.PI/2)*(paddles[0].gettrajmod(new theorypoint(GetMouseX(), GetMouseY()))/2)))
Line(GetMouseX(), GetScreenHeight(), GetMouseX()+Math.cos(angle)*100, GetScreenHeight()+Math.sin(angle)*100, White); 

}

FlipScreen();
//GetKey();
//soundHK();
if(lives==0){
gameover();
return "";
}
while(fips+16>GetTime()){processBlocks(false); processBalls(true);processPaddles(false); processDrops(); drawHud(); 
FlipScreen();}
}


}


